# -*- encoding: utf-8 -*-

import hashlib, sys

from django.conf import settings
from django.contrib.auth.backends import ModelBackend
from django.contrib.auth.models import User as DjangoUser, check_password

from datamaster_modeles.models import Authentification as RemoteUser

class CascadeBackend(ModelBackend):
    def authenticate(self, username=None, password=None):
        user = None

        # Prep des données
        if username.endswith ("@auf.org"):
            username = username.replace ("@auf.org", "")

        email = "%s@auf.org" % username
        md5pass = hashlib.md5(password.encode('utf-8')).hexdigest()

        # Cherche les comptes roa+locaux
        remoteUser = localUser = None
        try:
            if settings.AUTH_PASSWORD_REQUIRED:
                remoteUser = RemoteUser.objects.get (courriel=email, motdepasse=md5pass)
            else:
                remoteUser = RemoteUser.objects.get (courriel=email)
        except:
            pass
        try:
            localUser = DjangoUser.objects.get (username=username)
        except: pass
        
        # remoteUser : prenom et nom à partir de courriel
        if remoteUser:
            prenom_nom = email.replace('@auf.org','')
            prenom, sep, nom = prenom_nom.partition('.')
            remoteUser.prenom = prenom.title()
            remoteUser.nom = nom.title()
        
        # Si on a pas besoin du mdp, on doit copier qd meme,
        # il ne faut jamais retourner un "RemoteUser" ici
        if not settings.AUTH_PASSWORD_REQUIRED:
            if remoteUser and not localUser:
                localUser = DjangoUser (username = username,
                        email = email, 
                        first_name = remoteUser.prenom,
                        last_name = remoteUser.nom,
                        is_staff = True,
                        is_active = True,
                        is_superuser = False)
                localUser.set_password (password)
                localUser.save ()
            user = localUser
        # Gestion des comptes roa vs. local
        else:
            # Local existe pas, on doit de tte facon le creer
            if not localUser:
                localUser = DjangoUser (username = username,
                        email = email, 
                        is_staff = True,
                        is_active = True,
                        is_superuser = False)
            # Cas du compte local seul, on verifie le mot de passe
            elif not remoteUser:
                if localUser.check_password (password):
                    user = localUser
            # Compte roa, on valide le mot de passe distant et on
            # met a jour la copie locale
            if remoteUser:
                localUser.first_name = remoteUser.prenom
                localUser.last_name = remoteUser.nom
                # pass distant en md5
                localUser.set_password (password)
                localUser.save ()
                user = localUser

        return user
